/* --------------------------------------------------------------------------
   
   Domo - Dirks (Oberon) Music Organizer (http://domo.sf.net)

   Copyright (C) 2001 Dirk Gorissen, All Rights Reserved
   
   This application is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation;
   
   This application is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.
   
   You should have received a copy of the GNU General Public
   License along with this application; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

----------------------------------------------------------------------------*/

#ifndef INC_AUDIOCD_H
#define INC_AUDIOCD_H

#ifndef INC_CD_H
#include "cd.h"
#define INC_CD_H
#endif

#ifndef INC_TRACK_H
#include "track.h"
#define INC_TRACK_H
#endif

#ifndef INC_TEXTOSTREAM_H
#include "textostream.h"
#define INC_TEXTOSTREAM_H
#endif

using TrackSpace::Track;
using MediaSpace::CD;

namespace MediaSpace {

class AudioCD: public CD {
      private:
      int fYear;
      QString fArtist;
      QString fGenre;

      public:
      AudioCD(const QString, const QString, const QString="Various", const QString="None");
      AudioCD();
      virtual ~AudioCD();
			 
      QString getArtist() const;
      void setArtist(const QString);
	
      QString getGenre() const;
      void setGenre(const QString);
			
      int getYear() const;
      void setYear(const int);
      void setYear(const QString);
      
      void setTrackAttributes();
      void setTracklist(Track::Tracklist& tlist);
      Track::Tracklist* getTracklist();
      
      virtual void writeTxt(TextOStream* ostream) const;
      virtual void writeHtml(TextOStream* ostream) const;
      virtual void writeM3u(TextOStream* ostream) const;
      virtual void writeB4s(TextOStream* ostream) const;
      virtual void writePls(TextOStream* ostream) const;
      virtual void writeCsv(TextOStream* ostream, const QStringList& fields) const;
	
      virtual QString getTypeString() const;

};

} //Close namespace MediaSpace

#endif

