/* --------------------------------------------------------------------------
   
   Domo - Dirks (Oberon) Music Organizer (http://domo.sf.net)

   Copyright (C) 2001 Dirk Gorissen, All Rights Reserved
   
   This application is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation;
   
   This application is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.
   
   You should have received a copy of the GNU General Public
   License along with this application; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

----------------------------------------------------------------------------*/

#ifndef INC_CD_H
#define INC_CD_H

#ifndef INC_TRACK_H
#include "track.h"
#define INC_TRACK_H
#endif

#ifndef INC_FILE_H
#include "file.h"
#define INC_FILE_H
#endif

#ifndef INC_TEXTOSTREAM_H
#include "textostream.h"
#define INC_TEXTOSTREAM_H
#endif

#include "assert.h"
#include "qstringlist.h"
#include "qstring.h"

namespace MediaSpace {
    
using TrackSpace::Track;
using FileSpace::File;
using WriterSpace::TextOStream;

class CD {
	private:
	    
	protected:
	    QString fID;
	    int fFileCount;
	    QString fTitle;
	    QString fComment;
	    File::Filelist fFilelist;
	    
	public:
	    CD();
	    CD(const int i);
	    virtual ~CD();
	    int getID() const;
	    QString getIDString() const;
	    void setID(const int);
	    void setID(const QString);
	    
	    int getFileCount() const;
	    void setFileCount(const int);
	    void setFileCount(const QString);
	    
	    QString getTitle() const;
	    void setTitle(const QString);
	    
	    QString getComment() const;
	    void setComment(const QString);
	    
	    virtual void add(File* f);
	    void setFilelist(File::Filelist& f);
	    void clear();
	    
	    File::ConstFileIterator getConstBegin() const;
	    File::ConstFileIterator getConstEnd() const;
	    
	    File::FileIterator getBegin();
	    File::FileIterator getEnd();
	    
	    virtual void writeTxt(TextOStream* ostream) const;
	    virtual void writeHtml(TextOStream* ostream) const;
	    virtual void writeM3u(TextOStream* ostream) const;
	    virtual void writeB4s(TextOStream* ostream) const;
	    virtual void writePls(TextOStream* ostream) const;
	    virtual void writeCsv(TextOStream* ostream, const QStringList& fields) const;
	    
	    virtual void writeTxtFileList(TextOStream* ostream) const;	
	    virtual void writeHtmlFileList(TextOStream* ostream) const;	
	    virtual void writeM3uFileList(TextOStream* ostream) const;	
	    virtual void writeB4sFileList(TextOStream* ostream) const;
	    virtual void writePlsFileList(TextOStream* ostream) const;
	    virtual void writeCsvFileList(TextOStream* ostream, const QStringList& fields) const;
	    
	    virtual QString getTypeString() const;
	    
	    QString toString(const int i) const;
	    int toInt(const QString s) const;
	};
} //close MediaSpace

#endif
