/* --------------------------------------------------------------------------
   
   Domo - Dirks (Oberon) Music Organizer (http://domo.sf.net)

   Copyright (C) 2001 Dirk Gorissen, All Rights Reserved
   
   This application is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation;
   
   This application is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.
   
   You should have received a copy of the GNU General Public
   License along with this application; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

----------------------------------------------------------------------------*/

#ifndef INC_CDLOOKUP_H
#define INC_CDLOOKUP_H

#ifndef INC_AUDIOCD_H
#include "audiocd.h"
#define INC_AUDIOCD_H
#endif

#include "musicbrainz.h"
#include "qstring.h"
#include <vector>

using std::vector;
using MediaSpace::AudioCD;

class CDLookup {
    private:
    MusicBrainz* fMusicBrainzObj;
    
    public:
    CDLookup(const QString server="mm.musicbrainz.org" ,
	     const short port=80,
	     const QString device="/dev/cdrom");
    
    ~CDLookup();
    
    //throws Exception
    void lookupCD(vector<AudioCD*>& albumList, const bool getTracks=false);
    void setServer(const QString server, const short port);
    void setDevice(const QString device);
    bool authenticate(const QString username, const QString pwd);
    void setProxy(const QString proxy, const int port);
};

#endif
