/* --------------------------------------------------------------------------
   
   Domo - Dirks (Oberon) Music Organizer (http://domo.sf.net)

   Copyright (C) 2001 Dirk Gorissen, All Rights Reserved
   
   This application is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation;
   
   This application is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.
   
   You should have received a copy of the GNU General Public
   License along with this application; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

----------------------------------------------------------------------------*/

#ifndef INC_COLLECTION_H
#include "collection.h"
#define INC_COLLECTION_H
#endif

using MediaSpace::Collection;
using std::vector;
//-----------------------------------------------------------------------------------------------------------
Collection::Collection(){
	fID = 0;
	fComment = "";
	fTitle = "";
	fOwner = "";
	fDesc = "";
	fAudioCDCount = 0;
	fMp3CDCount = 0;
	fMovieCDCount = 0;
	fDataCDCount = 0;
}
//-----------------------------------------------------------------------------------------------------------
Collection::~Collection(){
    clear();
}
//-----------------------------------------------------------------------------------------------------------
void Collection::clear() {
    fID = 0;
    fComment = "";
    fTitle = "";
    fOwner = "";
    fDesc = "";
    
	std::vector<CD*>::iterator it = fCDList.begin();
    while(it != fCDList.end()) {
	delete (*it);
	++it;
    }
}
//-----------------------------------------------------------------------------------------------------------
QString Collection::getTitle() const {
	return fTitle;
}
//-----------------------------------------------------------------------------------------------------------
void Collection::setTitle(const QString s){
	fTitle = s;
}
//-----------------------------------------------------------------------------------------------------------
QString Collection::getOwner() const {
	return fOwner;
}
//-----------------------------------------------------------------------------------------------------------
void Collection::setOwner(const QString s){
	fOwner = s;
}
//-----------------------------------------------------------------------------------------------------------
QString Collection::getDesc() const {
	return fDesc;
}
//-----------------------------------------------------------------------------------------------------------
void Collection::setDesc(const QString s) {
	fDesc = s;
}
//-----------------------------------------------------------------------------------------------------------
QString Collection::getComment() const {
	return fComment;
}
//-----------------------------------------------------------------------------------------------------------
void Collection::setComment(const QString s) {
	fComment = s;
}
//-----------------------------------------------------------------------------------------------------------
void Collection::add(CD* m) {
    assert(m != 0);
    
    QString type = m->getTypeString();
    if (type == "MP3_CD") {
	++fMp3CDCount;
    } else if (type == "MOVIE_CD") {
	++fMovieCDCount;
    } else if (type == "DATA_CD") {
	++fDataCDCount;
    } else if (type == "AUDIO_CD") {
	++fAudioCDCount;
    } else {
	assert(false);
    }
    
    fCDList.push_back(m);
	
}
//-----------------------------------------------------------------------------------------------------------
Collection::ConstCDIterator Collection::getCDListBegin() const{
	return fCDList.begin();
}
//-----------------------------------------------------------------------------------------------------------
Collection::ConstCDIterator Collection::getCDListEnd() const{
	return fCDList.end();
}
//-----------------------------------------------------------------------------------------------------------
int Collection::getMp3CDCount() const {
	return fMp3CDCount;
}
//-----------------------------------------------------------------------------------------------------------
int Collection::getAudioCDCount() const{
	return fAudioCDCount;
}
//-----------------------------------------------------------------------------------------------------------
int Collection::getMovieCDCount() const {
	return fMovieCDCount;
}
//-----------------------------------------------------------------------------------------------------------
int Collection::getDataCDCount() const {
	return fDataCDCount;
}
//-----------------------------------------------------------------------------------------------------------
void Collection::setMp3CDCount(const int s) {
	fMp3CDCount = s;
}
//-----------------------------------------------------------------------------------------------------------
int Collection::getID() const {
	return fID;
}
//-----------------------------------------------------------------------------------------------------------
void Collection::setID(const QString s) {
	fID = s.toInt();
}
//-----------------------------------------------------------------------------------------------------------
void Collection::setID(const int s) {
	fID = s;
}
//-----------------------------------------------------------------------------------------------------------
void Collection::setMovieCDCount(const int s) {
	fMovieCDCount = s;
}
//-----------------------------------------------------------------------------------------------------------
void Collection::setAudioCDCount(const int s) {
	fAudioCDCount = s;
}
//-----------------------------------------------------------------------------------------------------------
void Collection::setDataCDCount(const int s) {
	fDataCDCount = s;
}
//-----------------------------------------------------------------------------------------------------------
void Collection::getTracks(Track::Tracklist& tlist) const {
	tlist.clear();
    /*ConstMp3CDListIterator MI = getMp3CDListBegin();
	ConstAudioCDListIterator AI = getAudioCDListBegin();
	File::FileIterator TI;
	
	while (MI != getMp3CDListEnd()) {
		TI = (*MI)->getBegin();
		while (TI != (*MI)->getEnd()) {
			tlist.push_back(*TI);
			++TI;
		}
		++MI;
	}

	while (AI != getAudioCDListEnd()) {
		TI = (*AI)->getBegin();
		while (TI != (*AI)->getEnd()) {
			tlist.push_back(*TI);
			++TI;
		}
		++AI;
	}		*/
}		
//-----------------------------------------------------------------------------------------------------------
