/* --------------------------------------------------------------------------
   
   Domo - Dirks (Oberon) Music Organizer (http://domo.sf.net)

   Copyright (C) 2001 Dirk Gorissen, All Rights Reserved
   
   This application is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation;
   
   This application is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.
   
   You should have received a copy of the GNU General Public
   License along with this application; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

----------------------------------------------------------------------------*/

void CsvDialog::setMode(const QString mode) {
    fileFields->setEnabled(false);
    trackFields->setEnabled(false);
    cdFields->setEnabled(false);
	
    if (mode == "MP3_CD") {
	cdyear->setEnabled(false);
	cdartist->setEnabled(false);
	cdFields->setEnabled(true);
    } else if (mode == "AUDIO_CD") {
	cdFields->setEnabled(true);
    } else {
	fileFields->setEnabled(true);
	trackFields->setEnabled(true);
    }
}

QStringList* CsvDialog::getSelectedFields(const QString mode) {
    QStringList* fields = new QStringList();
    
    if (mode == "MP3_CD") {
	if (cdid->isChecked()) fields->append("Id");
	if (cdtitle->isChecked()) fields->append("Title");
	if (cdfilecount->isChecked()) fields->append("FileCount");
	if (cdcomment->isChecked()) fields->append("Comment");
	
	if (cdgenre->isChecked()) fields->append("Genre");
    } else if (mode == "AUDIO_CD") {
	if (cdid->isChecked()) fields->append("Id");
	if (cdtitle->isChecked()) fields->append("Title");
	if (cdfilecount->isChecked()) fields->append("FileCount");
	if (cdcomment->isChecked()) fields->append("Comment");
	
	if (cdyear->isChecked()) fields->append("Year");
	if (cdartist->isChecked()) fields->append("Artist");
	if (cdgenre->isChecked()) fields->append("Genre");
    } else {
	if (filename->isChecked()) fields->append("Name");
	if (id->isChecked()) fields->append("Id");
	if (path->isChecked()) fields->append("Path");
	if (size->isChecked()) fields->append("Size");
	if (created->isChecked()) fields->append("Created");
	if (modified->isChecked()) fields->append("Modified");
	if (accessed->isChecked()) fields->append("Accessed");
	if (description->isChecked()) fields->append("Description");
	if (attributes->isChecked()) fields->append("Attributes");
	if (cdno->isChecked()) fields->append("CD id");
	if (trackno->isChecked()) fields->append("TrackNo");
	if (artist->isChecked()) fields->append("Artist");
	if (title->isChecked()) fields->append("Title");
	if (album->isChecked()) fields->append("Album");
	if (length->isChecked()) fields->append("Length");
	if (bitrate->isChecked()) fields->append("Bitrate");
	if (samplingrate->isChecked()) fields->append("Samplingrate");
	if (year->isChecked()) fields->append("Year");
	if (mood->isChecked()) fields->append("Mood");
	if (genre->isChecked()) fields->append("Genre");
	if (comment->isChecked()) fields->append("Comment");
	if (score->isChecked()) fields->append("Score");
}
    return fields;
}
