/* --------------------------------------------------------------------------
   
   Domo - Dirks (Oberon) Music Organizer (http://domo.sf.net)

   Copyright (C) 2001 Dirk Gorissen, All Rights Reserved
   
   This application is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation;
   
   This application is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.
   
   You should have received a copy of the GNU General Public
   License along with this application; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

----------------------------------------------------------------------------*/
#ifndef INC_IOEXCEPTION_H
#include "ioexception.h"
#define INC_IOEXCEPTION_H
#endif

#ifndef INC_DATACD_H
#include "datacd.h"
#define INC_DATACD_H
#endif

using FileSpace::File;
using TrackSpace::Track;
using MediaSpace::DataCD;
//-----------------------------------------------------------------------------------------------------------
DataCD::DataCD(const QString t, const QString c, const QString v) : CD(){
	fTitle = t;
	fComment = c;
	fVolumeLabel = v;
}
//-----------------------------------------------------------------------------------------------------------
DataCD::~DataCD(){
}
//-----------------------------------------------------------------------------------------------------------
QString DataCD::getVolumeLabel() const {
	return fVolumeLabel;
}
//-----------------------------------------------------------------------------------------------------------
void DataCD::setVolumeLabel(const QString v) {
	fVolumeLabel = v;
}
//-----------------------------------------------------------------------------------------------------------
void DataCD::writeTxt(TextOStream* ostr) const {
    if ((ostr == 0)||(!ostr->isGood())) throw (new IoException("DataCD::writeTxt","Pre: Ostream is 0 or not good"));
    
    CD::writeTxt(ostr);
    
    switch (ostr->getMode()) {
    case TextOStream::SHORT:
	break;
    case TextOStream::LONG:
	break;
    default:
	break;
    }
    writeTxtFileList(ostr);	
    
   if ((ostr == 0)||(!ostr->isGood())) throw (new IoException("DataCD::writeTxt","Post: Ostream is 0 or not good"));
}
//-----------------------------------------------------------------------------------------------------------
void DataCD::writeHtml(TextOStream* ostr) const{
    if ((ostr == 0)||(!ostr->isGood())) throw (new IoException("DataCD::writeHtml","Pre: Ostream is 0 or not good"));
    
    CD::writeHtml(ostr);
    
    switch (ostr->getMode()) {
    case TextOStream::SHORT:
	break;
    case TextOStream::LONG:
    default:
	break;
    }
    writeHtmlFileList(ostr);	
    
    if ((ostr == 0)||(!ostr->isGood())) throw (new IoException("DataCD::writeHtml","Post: Ostream is 0 or not good"));
}
//-----------------------------------------------------------------------------------------------------------
QString DataCD::getTypeString() const {
    return  "DATA_CD";    
}
//-----------------------------------------------------------------------------------------------------------
