TEMPLATE	= app
LANGUAGE	= C++

CONFIG	+= thread exceptions warn_on rtti stl debug

unix:LIBS	+= -lmusicbrainz -lvorbisfile -lmad -ltag

unix:INCLUDEPATH	+= /usr/include/musicbrainz/ /usr/include/taglib

HEADERS	+= audiocd.h \
	cd.h \
	collection.h \
	compare.h \
	createcol.ui.h \
	datacd.h \
	dbase.h \
	domomainwindow.h \
	domomainwindowbase.ui.h \
	file.h \
	filechooser.h \
	ireader.h \
	iwriter.h \
	moviecd.h \
	mp3cd.h \
	readerm3u.h \
	readertxt.h \
	b4shandler.h \
	settings.h \
	stringmanip.h \
	track.h \
	writerhtml.h \
	writerm3u.h \
	writertxt.h \
	textostream.h \
	setupdialog.h \
	rcman.h \
	dirscanner.h \
	textistream.h \
	log.h \
	cdlookup.h \
	exception.h \
	fileio.h \
	writerb4s.h \
	readerb4s.h \
	metainfo.h \
	readerpls.h \
	writerpls.h \
	domoglobals.h \
	dbaseexception.h \
	ioexception.h \
	dbasebackup.h \
	writercsv.h \
	readercsv.h \
	qmbtagger/qmbfile.h \
	qmbtagger/qmbfileview.h \
	qmbtagger/qmbmad.h \
	qmbtagger/qmbmetadata.h \
	qmbtagger/qmbmp3file.h \
	qmbtagger/qmbsubmit.h \
	qmbtagger/qmbvorbisfile.h \
	qmbtagger/vcedit.h \
	trmdialog.h \
	pgsqldbase.h \
	mysqldbase.h \
	readerfactory.h \
	dbasefactory.h \
	guilog.h \
	consistencychecker.h \
	consistencyprop.h \
	musicexpression.h \
	odbcdbase.h

SOURCES	+= audiocd.cpp \
	cd.cpp \
	collection.cpp \
	compare.cpp \
	datacd.cpp \
	dbase.cpp \
	domomainwindow.cpp \
	file.cpp \
	filechooser.cpp \
	ireader.cpp \
	iwriter.cpp \
	main.cpp \
	moviecd.cpp \
	mp3cd.cpp \
	readerm3u.cpp \
	readertxt.cpp \
	b4shandler.cpp \
	settings.cpp \
	stringmanip.cpp \
	track.cpp \
	writerhtml.cpp \
	writerm3u.cpp \
	writertxt.cpp \
	textostream.cpp \
	setupdialog.cpp \
	rcman.cpp \
	dirscanner.cpp \
	textistream.cpp \
	log.cpp \
	cdlookup.cpp \
	exception.cpp \
	fileio.cpp \
	writerb4s.cpp \
	readerb4s.cpp \
	metainfo.cpp \
	readerpls.cpp \
	writerpls.cpp \
	dbaseexception.cpp \
	domoglobals.cpp \
	ioexception.cpp \
	dbasebackup.cpp \
	writercsv.cpp \
	readercsv.cpp \
	qmbtagger/qmbfile.cpp \
	qmbtagger/qmbfileview.cpp \
	qmbtagger/qmbmad.cpp \
	qmbtagger/qmbmetadata.cpp \
	qmbtagger/qmbmp3file.cpp \
	qmbtagger/qmbsubmit.cpp \
	qmbtagger/qmbvorbisfile.cpp \
	qmbtagger/vcedit.c \
	trmdialog.cpp \
	pgsqldbase.cpp \
	mysqldbase.cpp \
	readerfactory.cpp \
	dbasefactory.cpp \
	guilog.cpp \
	consistencychecker.cpp \
	consistencyprop.cpp \
	musicexpression.cpp \
	odbcdbase.cpp

FORMS	= createcol.ui \
	domomainwindowbase.ui \
	preferencediag.ui \
	splittrackdiag.ui \
	setupdialogbase.ui \
	aboutdiag.ui \
	creditsdiag.ui \
	musicbrainzdialog.ui \
	newaccountdiag.ui \
	statsdialog.ui \
	welcomediag.ui \
	skiptrack.ui \
	backupdbasediag.ui \
	csvdialog.ui \
	langdialog.ui \
	enterTracksDialog.ui \
	cleandirdialog.ui \
	trackinfo.ui \
	renamealbumdialog.ui

IMAGES	= images/goritechlogo.bmp \
	images/musicbrainz.png \
	images/mysql.png \
	images/id3lib.png \
	images/qt.png \
	images/domologo.png \
	images/tux.png \
	images/domoicon.png \
	images/info.png \
	images/floppy.png \
	images/language.png \
	images/help.png \
	images/add.png \
	images/export.png \
	images/database.png \
	images/compare.png \
	images/wish.png \
	images/folder_sound.png \
	images/misc.png \
	images/audioCd.png \
	images/folder.png \
	images/statistics.png \
	images/browse.png \
	images/cd.png \
	images/musicnote.png \
	images/stop.png \
	images/refresh.png

DBFILE	= domo.db
# /* --------------------------------------------------------------------------
#   
#    Domo - Dirks (Oberon) Music Organizer (http://domo.sf.net)
# 
#    Copyright (C) 2001 Dirk Gorissen, All Rights Reserved
#    
#    This application is free software; you can redistribute it and/or
#    modify it under the terms of the GNU General Public
#    License as published by the Free Software Foundation;
#    
#    This application is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    General Public License for more details.
#    
#    You should have received a copy of the GNU General Public
#    License along with this application; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
# 
# ----------------------------------------------------------------------------*/





unix {
  UI_DIR = .ui
  MOC_DIR = .moc
  OBJECTS_DIR = .obj
}
TRANSLATIONS = languages/domo_es.ts \
	       languages/domo_en.ts \
	       languages/domo_de.ts \
	       languages/domo_nl.ts

	
TARGET = domo-2.4

# Qmake always adds -fno-exceptions
# even the following lines do not always work :s
# worst case: modify /usr/lib/qt-3.3.x/mkspecs/linux-g++/qmake++/qmake.conf
QMAKE_CFLAGS_RELEASE -= -fno-exceptions
QMAKE_CXXFLAGS_RELEASE -= -fno-exceptions
QMAKE_CFLAGS_DEBUG -= -fno-exceptions
QMAKE_CXXFLAGS_DEBUG -= -fno-exceptions

QMAKE_CFLAGS_DEBUG += -fno-inline
QMAKE_CXXFLAGS_DEBUG += -fno-inline

QMAKE_CXXFLAGS_RELEASE += -fexceptions
QMAKE_CXXFLAGS_DEBUG += -fexceptions

DISTFILES += *.spec resources/*.txt images/splashscreen.png languages/*.qm INSTALL RELEASE README CHANGELOG COPYING

documentation.path = /etc/domo/doc
documentation.files = INSTALL RELEASE README CHANGELOG COPYING
INSTALLS += documentation

resources.path = /etc/domo/resources
resources.files = resources/*.txt
INSTALLS += resources

images.path = /etc/domo/images
images.files = images/splashscreen.png
INSTALLS += images

languages.path = /etc/domo/languages
languages.extra = $(QTDIR)/bin/lrelease domo.pro
languages.files = languages/*.qm
INSTALLS += languages

# target.path = /usr/local/domo
# INSTALLS += target

# ugly workaround due to weird qmake problem
# this is only necessary when running qmake in certain directories.
# see post at http://lists.trolltech.com/qt-interest/2004-01/thread00185-0.html
# this makes that uninstall is not completely correct (some files are left)

target.path = /tmp/domo
INSTALLS += target

posttarget.path = /tmp/domo
posttarget.extra = $(MKDIR) $(INSTALL_ROOT)/usr/bin/; cp $(INSTALL_ROOT)/tmp/domo/$(QMAKE_TARGET) $(INSTALL_ROOT)/usr/bin/domo; rm -rf $(INSTALL_ROOT)/tmp/domo;
#posttarget.extra = $(MKDIR) $(INSTALL_ROOT)/usr/local/bin/; cp $(INSTALL_ROOT)/tmp/domo/$(QMAKE_TARGET) $(INSTALL_ROOT)/usr/local/bin/domo; rm -rf $(INSTALL_ROOT)/tmp/domo;
INSTALLS += posttarget









