/* --------------------------------------------------------------------------
   
   Domo - Dirks (Oberon) Music Organizer (http://domo.sf.net)

   Copyright (C) 2001 Dirk Gorissen, All Rights Reserved
   
   This application is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation;
   
   This application is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.
   
   You should have received a copy of the GNU General Public
   License along with this application; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

----------------------------------------------------------------------------*/

#ifndef INC_DOMOGLOBALS_H
#include "domoglobals.h"
#define INC_DOMOGLOBALS_H
#endif

//Directory Separator
const QString DomoGlobals::DIR_SEP = QChar(QDir::separator());

//Domo directories
const QString DomoGlobals::LANGUAGE_DIR = "languages";
const QString DomoGlobals::RESOURCE_DIR = "resources";
const QString DomoGlobals::IMAGE_DIR = "images";

const QString DomoGlobals::DOMO_DIR = QDir::homeDirPath() 
          + DomoGlobals::DIR_SEP 
          + ".domo" 
          + DomoGlobals::DIR_SEP;

#if defined(WIN32)
const QString DomoGlobals::CONFIG_DIR = DomoGlobals::DOMO_DIR + 
     DomoGlobals::DIR_SEP + "etc";  
#else
  const QString DomoGlobals::CONFIG_DIR = "/etc/domo/";  
#endif

//Domo misc files
const QString DomoGlobals::SETTINGS_FNAME = "domo.conf";

//Domo resource files
const QString DomoGlobals::EXTINFO_FILE = DomoGlobals::RESOURCE_DIR 
         + DomoGlobals::DIR_SEP +  "extinfo.txt";

const QString DomoGlobals::GENRELIST_FILE = DomoGlobals::RESOURCE_DIR 
         + DomoGlobals::DIR_SEP + "genrelist.txt";

const QString DomoGlobals::ARTISTSAFELIST_FILE = DomoGlobals::RESOURCE_DIR 
         + DomoGlobals::DIR_SEP + "artistsafelist.txt";

const QString DomoGlobals::KEYWORDS_FILE = DomoGlobals::RESOURCE_DIR 
         + DomoGlobals::DIR_SEP + "keywords.txt";

const QString DomoGlobals::HYPHENEDARTISTS_FILE = DomoGlobals::RESOURCE_DIR 
         + DomoGlobals::DIR_SEP + "hyphenedartists.txt";

const QString DomoGlobals::SPLASHSCREEN = DomoGlobals::IMAGE_DIR
       + DomoGlobals::DIR_SEP 
       + "splashscreen.png";

//Important globals
const QString DomoGlobals::LOG_FILE = DomoGlobals::DOMO_DIR + "domo.log";
const QString DomoGlobals::DOMO_VERSION = "2.4";
const QString DomoGlobals::AUTHOR_MAIL = "Dgorissen@gmx.net";

const QString DomoGlobals::MUSIC_MASK = "*.mp3 *.mp2 *.MP3 *.MP2 *.ogg *.OGG *.wma *.WMA *.wav *.WAV *.flac *.FLAC";
const QString DomoGlobals::FILE_TYPES = "*.b4s *.txt *.Txt *.m3u *.pls *.csv";
const QStringList DomoGlobals::LANGUAGES = QStringList::split("|","English (default)|Deutsch (domo_de.qm)|Espaol (domo_es.qm)|Nederlands (domo_nl.qm)|");
const QStringList DomoGlobals::DBDRIVERS = QStringList::split(",","QMYSQL3");
//const QStringList DomoGlobals::DBDRIVERS = QStringList::split(",","QMYSQL3,QPSQL7,QODBC3");

const QStringList DomoGlobals::MoodList = QStringList::split(",","Adventurous,Angry,Any,Bored,Calm,Chill-out,Cocky,Depressed,Drunk,Energetic,Funny,Happy,High,In Love,Indescribable,Lazy,Lethargic,Lonely,Meditating,Mellow,Nostalgic,Rebellious,Refreshed,Restless,Sad,Scared,Sexy,Silly,Sleepy,Thoughtful,Tired");

//See http://www.chuayw.aznpride.net/3gdagreat/list.php  for more moods

Log* DomoGlobals::logger = 0;
