/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/

void EnterTracksDialog::init() {
    trackTable->adjustColumn(0);
    trackTable->adjustColumn(1);
    trackTable->adjustColumn(2);
    trackTable->adjustColumn(3);
}

void EnterTracksDialog::setTitle(QString title) {
    titleLine->setText(title);
}

void EnterTracksDialog::setArtist(QString artist) {
    artistLine->setText(artist);
}

QString EnterTracksDialog::getArtist() {
    if (useSameArtist->isChecked()) {
	return artistLine->text();
    } else {
	return "Various";
    }
}

void EnterTracksDialog::hideArtist(bool b) {
    if (b) {
	trackTable->hideColumn(0);
    } else {
    	trackTable->showColumn(0);
    }
}

TrackSpace::Track::Tracklist* EnterTracksDialog::getTracks() {
    TrackSpace::Track::Tracklist* tlist = new TrackSpace::Track::Tracklist();
    TrackSpace::Track* t = 0;
    QString artist = artistLine->text();
    QString comment = "";
    QString title = "";
    int length = 0;
    
    for(int r = 0; r < trackTable->numRows();++r) {
	if(!useSameArtist->isChecked()) artist = trackTable->text(r,0);
	title = trackTable->text(r,1);
	length = trackTable->text(r,2).toInt();
	comment =  trackTable->text(r,3);
	if (title == QString::null) title = "";
	if (artist == QString::null) artist = "";
	if (comment == QString::null) comment = "";
	
	t = new TrackSpace::Track(artist, title, comment, r+1);
	t->setLength(length);
	t->setName( (artist + " - " + title) );
	t->setDescription("Audio CD track (cda)");
	t->setReadOnly(true);
	tlist->push_back(t);
    }
    return tlist;
}

void EnterTracksDialog::close() {
    if (useSameArtist->isChecked() && empty(artistLine->text())) {
        QMessageBox mb( tr("Empty artist"),
        tr("Empty artist!"),
        QMessageBox::Warning,
        QMessageBox::Ok | QMessageBox::Default,
        QMessageBox::NoButton, 
        QMessageBox::NoButton,this );
        mb.exec();

    } else {
	QString tmp;
	int startCol = 0;
	if(useSameArtist->isChecked()) startCol = 1;
	bool emp = false;
	for(int r = 0; r < trackTable->numRows() && !emp ; ++r) {
	    for(int c = startCol; c < 2 && !emp ; ++c) {
		tmp = trackTable->text(r,c);
		if (tmp == QString::null || tmp.stripWhiteSpace() == "") {
		    emp = true;
		    qWarning("on (" + tmp.setNum(r) + "," + tmp.setNum(c) + ")");
		}
	    }
	}

	if (!emp) {
	    this->accept();
	} else {

	    QMessageBox mb2( tr("Empty cell"),
			    tr("Blank artist and/or title!"),
			    QMessageBox::Warning,
			    QMessageBox::Ok | QMessageBox::Default,
			    QMessageBox::NoButton, 
			    QMessageBox::NoButton,this );
	    mb2.exec();

	}

    }

}
