/* --------------------------------------------------------------------------
   
   Domo - Dirks (Oberon) Music Organizer (http://domo.sf.net)

   Copyright (C) 2001 Dirk Gorissen, All Rights Reserved
   
   This application is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation;
   
   This application is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.
   
   You should have received a copy of the GNU General Public
   License along with this application; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

----------------------------------------------------------------------------*/
#ifndef INC_IOEXCEPTION_H
#include "ioexception.h"
#define INC_IOEXCEPTION_H
#endif

#ifndef INC_FILE_H
#include "file.h"
#define INC_FIlE_H
#endif

#ifndef INC_STRINGMANIP_H
#include "stringmanip.h"
#define INC_STRINGMANIP_H
#endif

#ifndef INC_DOMOGLOBALS_H
#include "domoglobals.h"
#define INC_DOMOGLOBALS_H
#endif

#include <iostream>
using std::ostream;
using std::endl;
using std::cout;
using FileSpace::File;

//-----------------------------------------------------------------------------------------------------------
File::File(){
 fName = "";
 fDesc = "";
 fPath = "";
 fSize = 0;
 fCreated = "";
 fModified = "";
 fAccessed = "";
 fCDno = 0;
 fID = 0;
 fAttributes = QStringList();
} 
//-----------------------------------------------------------------------------------------------------------
File::File(const QString n, const QString d, const long s) {
 fName = n;
 fDesc = d;
 fSize = s;
 fPath = "";
 fCreated = "";
 fModified = "";
 fAccessed = "";
 fCDno = 0;
 fID = 0;
 fAttributes = QStringList();
}
//-----------------------------------------------------------------------------------------------------------
File::File(const File& f) {
 fName = f.getName();
 fDesc = f.getDescription();
 fSize = f.getSize();
 fCreated = f.getCreated();
 fPath = f.getPath();
 fModified = f.getModified();
 fAccessed = f.getAccessed();
 fCDno = f.getCDno();
 fID = f.getID();
 fAttributes = QStringList::split(",",f.getAttributes());
} 
//-----------------------------------------------------------------------------------------------------------
File::~File() {
    /*  Some tracks cause this: (WHY?)
    Program received signal SIGSEGV, Segmentation fault.
[Switching to Thread 16384 (LWP 3193)]
0x0806bac7 in ~QValueListPrivate (this=0x84a5c98) at qvaluelist.h:279
279             NodePtr x = p->next;
(gdb) bt
#0  0x0806bac7 in ~QValueListPrivate (this=0x84a5c98) at qvaluelist.h:279
#1  0x0806b4f9 in QValueListPrivate<QString>::derefAndDelete() (this=0x84a5c98) at qvaluelist.h:235
#2  0x0806b4b5 in ~QValueList (this=0x84a5e98) at qvaluelist.h:440
#3  0x0806b49d in ~QStringList (this=0x84a5e98) at qsettings.h:98
#4  0x0809486f in ~File (this=0x84a5e70) at file.cpp:87
#5  0x080eb463 in ConsistencyChecker::makeConsistent(std::vector<TrackSpace::Track*, std::allocator<TrackSpace::Track*> >&, QProgressBar*) (this=0x837a748,
    tlist=@0x3fffc8a0, progressBar=0x831da58) at consistencychecker.cpp:321
#6  0x0808307c in DOMOMainWindow::addCD() (this=0x3fffd350) at domomainwindow.cpp:382
#7  0x081835a6 in DOMOMainWindowBase::qt_invoke(int, QUObject*) (this=0x3fffd350, _id=61, _o=0x3fffc9b0) at .moc/moc_domomainwindowbase.cpp:151
#8  0x08180f2a in DOMOMainWindow::qt_invoke(int, QUObject*) (this=0x3fffd350, _id=61, _o=0x3fffc9b0) at .moc/moc_domomainwindow.cpp:132
*/

 //   fAttributes.clear();
    
 /* With the above statement 
 Program received signal SIGSEGV, Segmentation fault.
[Switching to Thread 16384 (LWP 3231)]
0x080eb50a in ConsistencyChecker::makeConsistent(std::vector<TrackSpace::Track*, std::allocator<TrackSpace::Track*> >&,
    tlist=@0x3fffd5a0, progressBar=0x831db68) at consistencychecker.cpp:320
320                 delete (*TI);
(gdb) bt
#0  0x080eb50a in ConsistencyChecker::makeConsistent(std::vector<TrackSpace::Track*, std::allocator<TrackSpace::Track*>
    tlist=@0x3fffd5a0, progressBar=0x831db68) at consistencychecker.cpp:320
#1  0x0808307c in DOMOMainWindow::addCD() (this=0x3fffe050) at domomainwindow.cpp:382
#2  0x08183652 in DOMOMainWindowBase::qt_invoke(int, QUObject*) (this=0x3fffe050, _id=61, _o=0x3fffd6b0) at .moc/moc_do
#3  0x08180fd6 in DOMOMainWindow::qt_invoke(int, QUObject*) (this=0x3fffe050, _id=61, _o=0x3fffd6b0) at .moc/moc_domoma
(gdb)
*/
       
}
//-----------------------------------------------------------------------------------------------------------
QString File::getDescription() const {
 return fDesc;
}
//-----------------------------------------------------------------------------------------------------------
void File::setDescription(const QString d) {
 fDesc = d;
}
//-----------------------------------------------------------------------------------------------------------
QString File::getName() const {
 return fName;
}
//-----------------------------------------------------------------------------------------------------------
void File::setPath(const QString s) {
 fPath = s;
}
//-----------------------------------------------------------------------------------------------------------
QString File::getPath() const {
 return fPath;
}
//-----------------------------------------------------------------------------------------------------------
void File::setName(const QString n) {
 fName = n;
}
//-----------------------------------------------------------------------------------------------------------
long File::getSize() const {
 return fSize;
}
//-----------------------------------------------------------------------------------------------------------
void File::setSize(const long l) {
 fSize = l;
}
//-----------------------------------------------------------------------------------------------------------
void File::setSize(const QString s) {
 fSize = s.toInt();
}
//-----------------------------------------------------------------------------------------------------------
QString File::getCreated() const {
 return fCreated;
}
//-----------------------------------------------------------------------------------------------------------
QString File::getModified() const {
 return fModified;
}
//-----------------------------------------------------------------------------------------------------------
QString File::getAccessed() const {
 return fAccessed;
}
//-----------------------------------------------------------------------------------------------------------
void File::setCreated(const QString d) {
 fCreated = d;
}
//-----------------------------------------------------------------------------------------------------------
void File::setModified(const QString d) {
 fModified = d;
}
//-----------------------------------------------------------------------------------------------------------
void File::setAccessed(const QString d) {
 fAccessed = d;
}
//-----------------------------------------------------------------------------------------------------------
void File::setHidden(const bool b){
 if (b) fAttributes.append("HIDDEN");
}
//-----------------------------------------------------------------------------------------------------------
void File::setReadOnly(const bool b){
 if (b) fAttributes.append("READ_ONLY");
}
//-----------------------------------------------------------------------------------------------------------
void File::setDirectory(const bool b){
 if (b) fAttributes.append("DIRECTORY");
}
//-----------------------------------------------------------------------------------------------------------
void File::setAttributes(const QString s){
    fAttributes = QStringList::split(",",s);
}
//-----------------------------------------------------------------------------------------------------------
QString File::getAttributes() const{
    return fAttributes.join(",");
}
//-----------------------------------------------------------------------------------------------------------
QString File::getExtension() const {
    return ::getExtension(fName);
}
//-----------------------------------------------------------------------------------------------------------
ostream& operator<<(ostream& out, FileSpace::File& f){
    
    out<<"Filename: "  << f.getName()    << endl;
    out<<"Path: "      << f.getPath()    << endl;
    out<<"Size: "      << f.getSize()    << " bytes" << endl;
    out<<"Created on: "<< f.getCreated() << endl;
    out<<"Modified on: "<< f.getModified() << endl;
    out<<"Accessed on: "<< f.getAccessed() << endl;
    out<<"Description: "<< f.getDescription() << endl;
    out<<"Attributes:"  << f.getAttributes() << endl;
    
    return out;
}
//-----------------------------------------------------------------------------------------------------------
int File::getCDno() const{
 return fCDno;
}
//-----------------------------------------------------------------------------------------------------------
void File::setCDno(const int i){
 fCDno = i;
}
//-----------------------------------------------------------------------------------------------------------
void File::setCDno(const QString i){
 fCDno = i.toInt();
}
//-----------------------------------------------------------------------------------------------------------
int File::getID() const{
 return fID;
}
//-----------------------------------------------------------------------------------------------------------
void File::setID(const int i){
 fID = i;
}
//-----------------------------------------------------------------------------------------------------------
void File::setID(const QString i){
 fID = i.toInt();
}
//-----------------------------------------------------------------------------------------------------------
void File::writeTxt(TextOStream* ostr) const{
    if ((ostr == 0)||(!ostr->isGood())) throw (new IoException("File::writeTxt","Pre: Ostream is 0 or not good"));

    switch (ostr->getMode()) {    
    case TextOStream::SHORT:
 *ostr <<"Filename: "     << fName    << "\n";
 break;
    case TextOStream::LONG:
    *ostr <<"Filename: "     << fName    << "\n";
 if (!empty(fID))  *ostr <<"ID: "           << fID              << "\n";
 if (!empty(fPath))  *ostr <<"Path: "         << fPath           << "\n";
 if (!empty(fSize))  *ostr <<"Size: "         << fSize/1000   << " Kb" << "\n";
 if (!empty(fCreated))  *ostr <<"Created on: "   << fCreated      << "\n";
 if (!empty(fModified)) *ostr <<"Modified on: "  << fModified     << "\n";
 if (!empty(fAccessed)) *ostr <<"Accessed on: "  << fAccessed   << "\n";
 if (!empty(fDesc))  *ostr <<"Description: "  << fDesc         << "\n";
 if (!empty(getAttributes())) *ostr <<"Attributes: "      << getAttributes()    << "\n";
 break;
    default:
 break;
    }
    if ((ostr == 0)||(!ostr->isGood())) throw (new IoException("File::writeTxt","Post: Ostream is 0 or not good"));
}
//-----------------------------------------------------------------------------------------------------------
void File::writeHtml(TextOStream* ostr) const {
    if ((ostr == 0)||(!ostr->isGood())) throw (new IoException("File::writeHtml","Pre: Ostream is 0 or not good"));
 
    switch (ostr->getMode()) {
    case TextOStream::SHORT:
 *ostr << fName << "<br>\n";
 break;
    case TextOStream::LONG:
 *ostr << "<b>File: </b>" << fName << "\n";
 *ostr << "<ul>\n";
 if (!empty(fID))     *ostr << "   <li><b>ID: </b>"         << fID   << "</li>\n";
 if (!empty(fDesc))       *ostr << "   <li><b>Desc: </b>"         << fDesc  << "</li>\n";
 if (!empty(fSize))   *ostr << "   <li><b>Size: </b>"         << fSize/1000  << " Kb</li>\n";
 if (!empty(fCreated))    *ostr << "   <li><b>Created: </b>"  << fCreated      << "</li>\n";
 if (!empty(fModified))   *ostr << "   <li><b>Modified: </b>"    << fModified   << "</li>\n";
 if (!empty(fAccessed))  *ostr << "   <li><b>Accessed: </b>"  << fAccessed     << "</li>\n";
 if (!empty(fPath))       *ostr << "   <li><b>Path: </b>"         << fPath    << "</li>\n";
 if (!empty(getAttributes()))  *ostr << "   <li><b>Attributes: </b>"   << getAttributes() << "</li>\n";
 *ostr << "</ul>\n";
 break;
    default:
 break;
    }
 
    if ((ostr == 0)||(!ostr->isGood())) throw (new IoException("File::writeHtml","Post: Ostream is 0 or not good"));
}
//-----------------------------------------------------------------------------------------------------------
void File::writeCsv(TextOStream* ostr,const QStringList& fields) const {
    if ((ostr == 0)||(!ostr->isGood())) throw (new IoException("File::writeCsv","Pre: Ostream is 0 or not good"));
    
    if (fields.contains("Name")) *ostr << fName    << ";";
    if (fields.contains("Id")) *ostr << fID              << ";";
    if (fields.contains("Path")) *ostr << fPath           << ";";
    if (fields.contains("Size")) *ostr << fSize/1000   << ";";
    if (fields.contains("Created")) *ostr   << fCreated      << ";";
    if (fields.contains("Modified")) *ostr   << fModified     << ";";
    if (fields.contains("Accessed")) *ostr << fAccessed   << ";";
    if (fields.contains("Description")) *ostr << fDesc         << ";";
    if (fields.contains("Attributes")) *ostr << getAttributes()    << ";";
    if (fields.contains("CD id")) *ostr << fCDno              << ";";
    
    if ((ostr == 0)||(!ostr->isGood())) throw (new IoException("File::writeCsv","Post: Ostream is 0 or not good"));
}
//-----------------------------------------------------------------------------------------------------------
//Music only format
void File::writeM3u(TextOStream* ostr) const {
    if ((ostr == 0)||(!ostr->isGood())) throw (new IoException("File::writeM3u","Pre: Ostream is 0 or not good"));
}
//-----------------------------------------------------------------------------------------------------------
//Music only format
void File::writeB4s(TextOStream* ostr) const{
    if ((ostr == 0)||(!ostr->isGood())) throw (new IoException("File::writeB4s","Pre: Ostream is 0 or not good"));
}
//-----------------------------------------------------------------------------------------------------------
//Music only format
void File::writePls(TextOStream* ostr,const uint num) const {
    if ((ostr == 0)||(!ostr->isGood())) throw (new IoException("File::writePls","Pre: Ostream is 0 or not good"));
    if (num == 0) { };
}
//-----------------------------------------------------------------------------------------------------------
QString File::absPath() const {
    return fPath + DomoGlobals::DIR_SEP + fName;
}
//-----------------------------------------------------------------------------------------------------------
