/* --------------------------------------------------------------------------
   
   Domo - Dirks (Oberon) Music Organizer (http://domo.sf.net)

   Copyright (C) 2001 Dirk Gorissen, All Rights Reserved
   
   This application is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation;
   
   This application is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.
   
   You should have received a copy of the GNU General Public
   License along with this application; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

----------------------------------------------------------------------------*/

#ifndef FILECHOOSER_H
#define FILECHOOSER_H

#include <qwidget.h>

class QLineEdit;
class QPushButton;
class QCheckBox;

class FileChooser : public QWidget
{
    Q_OBJECT

    Q_ENUMS( Mode )
    Q_PROPERTY( Mode mode READ mode WRITE setMode )
    Q_PROPERTY( QString fileName READ fileName WRITE setFileName )

public:
    FileChooser( QWidget *parent = 0, const char *name = 0);

    enum Mode { File, Directory };

    QString fileName() const;
    Mode mode() const;
    bool onlyDirs();
    void disableDirs();

public slots:
    void setFileName( const QString &fn );
    void setMode( Mode m );
    void setOnlyDirs( bool b );
   bool chooseFile();

signals:
    void fileNameChanged( const QString & );

private slots:

private:
    QLineEdit *lineEdit;
    QPushButton *button;
	QCheckBox *checkBox;
    Mode md;

};

#endif
