/* --------------------------------------------------------------------------
   
   Domo - Dirks (Oberon) Music Organizer (http://domo.sf.net)

   Copyright (C) 2001 Dirk Gorissen, All Rights Reserved
   
   This application is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation;
   
   This application is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.
   
   You should have received a copy of the GNU General Public
   License along with this application; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

----------------------------------------------------------------------------*/
#ifndef INC_FILEIO_H
#define INC_FILEIO_H

#include "qstring.h"
#include "qdir.h"

class FileIO {
    private:
    
    public:
    FileIO();
    virtual ~FileIO();
    
    static bool copyFile(const QString source, const QString destination);
    static bool exists(const QString name);
    static bool deleteFile(const QString name);
    static bool deleteDirectory(const QString d);
    static bool renameFile(const QString oldname, const QString newname);
    static bool isDirectory(const QString name);
    static bool isReadable(const QString name);
    static bool isWriteable(const QString name);
    static void splitAbsPath(const QString absPath, QString& dir, QString& fname);
    
    /*    static bool isDir(const QString name);
    static bool isFile(const QString name); */
};

#endif
