/* --------------------------------------------------------------------------
   
   Domo - Dirks (Oberon) Music Organizer (http://domo.sf.net)

   Copyright (C) 2001 Dirk Gorissen, All Rights Reserved
   
   This application is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation;
   
   This application is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.
   
   You should have received a copy of the GNU General Public
   License along with this application; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

----------------------------------------------------------------------------*/


#ifndef INC_DOMOGLOBALS_H
#include "domoglobals.h"
#define INC_DOMOGLOBALS_H
#endif

#ifndef INC_GUILOG_H
#include "guilog.h"
#define INC_GUILOG_H
#endif

#include "qdatetime.h"
#include "assert.h"
#include <iostream>
using std::cout;
//-----------------------------------------------------------------------------------------------------------
GuiLog::GuiLog(QTextEdit* textEdit ) : Log() {
   fTextEdit = textEdit;
}
//-----------------------------------------------------------------------------------------------------------
void GuiLog::open() {
}
//-----------------------------------------------------------------------------------------------------------
GuiLog::~GuiLog() {
}
//-----------------------------------------------------------------------------------------------------------
bool GuiLog::append(const QString s, const uint debug) {
    assert(fTextEdit != 0);
    
    if (debug <= getDebugLevel()) {
	fTextEdit->append(s);
    }
    return true;
}
//-----------------------------------------------------------------------------------------------------------
bool GuiLog::append(const QString method, const QString s, const uint debug) {
    assert(fTextEdit != 0);
    
    if (debug <= getDebugLevel()) {
	fTextEdit->append(s);
    }
    return true;
}
//-----------------------------------------------------------------------------------------------------------
bool GuiLog::error(const QString method, const QString msg) {
    Log::error(method,msg);
    return append(method,"<font color=\"#ff0000\"><u>ERROR:</u> : " + msg + "</font>",0);
}
//-----------------------------------------------------------------------------------------------------------
bool GuiLog::warning(const QString method, const QString msg) {
    Log::warning(method,msg);
    return append(method,"<font color=\"#00aa00\"><u>Warning:</u> " + msg + "</font>",1);
}
//-----------------------------------------------------------------------------------------------------------
bool GuiLog::info(const QString method, const QString msg) {
    Log::info(method,msg);
    return append(method, "<font color=\"#0000ff\">" + msg + "</font>",2);
}
//-----------------------------------------------------------------------------------------------------------
bool GuiLog::debug(const QString method, const QString msg) {
    Log::debug(method,msg);
    return append(method,"<font color=\"#0000ff\">" + msg + "</font>",3);
}
//-----------------------------------------------------------------------------------------------------------
bool GuiLog::exception(const QString method, const QString msg) {
     Log::exception(method,msg);
   //dilemma: cleanXml(msg) or not.... msg, may contain '<' characters which screws rich text output
    //however, using cleanXml(msg) obscures original error....
    
    return append(method,"<font color=\"#ffaa00\"><u>Exception:</u> " + msg + "</font>",0);
}
//-----------------------------------------------------------------------------------------------------------
