/* --------------------------------------------------------------------------
   
   Domo - Dirks (Oberon) Music Organizer (http://domo.sf.net)

   Copyright (C) 2001 Dirk Gorissen, All Rights Reserved
   
   This application is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation;
   
   This application is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.
   
   You should have received a copy of the GNU General Public
   License along with this application; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

----------------------------------------------------------------------------*/

#ifndef INC_GUILOG_H
#define INC_GUILOG_H

#include "qtextedit.h"
#include "log.h"

class GuiLog: public Log{
private:
    QTextEdit* fTextEdit;
    bool append(const QString s, const uint debug = 2);
    bool append(const QString method, const QString s, const uint debug = 2);
    
public:
    GuiLog(QTextEdit* target);
    
    virtual ~GuiLog();
    
    virtual void open();
    virtual bool error(const QString method, const QString msg);
    virtual bool warning(const QString method, const QString msg);
    virtual bool info(const QString method, const QString msg);
    virtual bool debug(const QString method, const QString msg);
    virtual bool exception(const QString method, const QString msg);
};

#endif
