/* --------------------------------------------------------------------------
   
   Domo - Dirks (Oberon) Music Organizer (http://domo.sf.net)

   Copyright (C) 2001 Dirk Gorissen, All Rights Reserved
   
   This application is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation;
   
   This application is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.
   
   You should have received a copy of the GNU General Public
   License along with this application; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

----------------------------------------------------------------------------*/
#ifndef INC_IOEXCEPTION_H
#include "ioexception.h"
#define INC_IOEXCEPTION_H
#endif

#ifndef INC_IREADER_H
#include "ireader.h"
#define INC_IREADER_H
#endif

#include "assert.h"

using ReaderSpace::IReader;

//-----------------------------------------------------------------------------------------------------------
IReader::IReader(const QString s) {
    assert(s != "");    
    fFilename = s;
    fFile = 0;
    openFile();   
}
//-----------------------------------------------------------------------------------------------------------
IReader::~IReader(){
}
//-----------------------------------------------------------------------------------------------------------
void IReader::setFilename(const QString s){
	fFilename = s;
}
//-----------------------------------------------------------------------------------------------------------
QString IReader::getFilename() const{
	return fFilename;
}
//-----------------------------------------------------------------------------------------------------------
void IReader::changeFileTo(const QString s) {
    closeFile();
    setFilename(s);
    openFile();
}
//-----------------------------------------------------------------------------------------------------------
void IReader::openFile(){
    if (fFile != 0) delete fFile;
    fFile = new TextIStream(fFilename);
    if (fFile == 0) throw (new IoException("IReader::openFile","fFile is 0, current file is '" + fFilename + "'"));
    if (!fFile->isGood()) throw (new IoException("IReader::openFile","fFile is not good, current file is '" + fFilename + "'"));

}
//-----------------------------------------------------------------------------------------------------------
void IReader::closeFile(){
    if (fFile == 0) throw (new IoException("IReader::closeFile","fFile is 0, current file is '" + fFilename + "'"));
    (fFile->device())->close();
    fFile->unsetDevice();
}
//-----------------------------------------------------------------------------------------------------------
TextIStream* IReader::getStream() {
    return fFile;
}
//-----------------------------------------------------------------------------------------------------------
