/* --------------------------------------------------------------------------
   
   Domo - Dirks (Oberon) Music Organizer (http://domo.sf.net)

   Copyright (C) 2001 Dirk Gorissen, All Rights Reserved
   
   This application is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation;
   
   This application is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.
   
   You should have received a copy of the GNU General Public
   License along with this application; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

----------------------------------------------------------------------------*/

#ifndef INC_IREADER_H
#define INC_IREADER_H

#ifndef INC_TRACK_H
#include "track.h"
#define INC_TRACK_H
#endif

#ifndef INC_TEXTISTREAM_H
#include "textistream.h"
#define INC_TEXTISTREAM_H
#endif

using TrackSpace::Track;
using ReaderSpace::TextIStream;

namespace ReaderSpace {
    
    class IReader {
    private:
	QString fFilename;
	TextIStream* fFile;
    public:
	IReader(const QString);
	virtual ~IReader();
	
	void setFilename(const QString);
	QString getFilename() const;
	
	TextIStream* getStream();
	void changeFileTo(const QString);
	void openFile();
	void closeFile();
	
	virtual void read(Track::Tracklist& tlist)=0;
    };
    
} //close namespace IReaderSpace

#endif

