/* --------------------------------------------------------------------------
   
   Domo - Dirks (Oberon) Music Organizer (http://domo.sf.net)

   Copyright (C) 2001 Dirk Gorissen, All Rights Reserved
   
   This application is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation;
   
   This application is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.
   
   You should have received a copy of the GNU General Public
   License along with this application; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

----------------------------------------------------------------------------*/

#ifndef INC_IWRITER_H
#define INC_IWRITER_H

#include "textostream.h"
#include "cd.h"

using MediaSpace::CD;

namespace WriterSpace {
    
    class IWriter {
    private:
	QString fFilename;
	TextOStream* fFile;       
	
    public:
	IWriter();
	IWriter(const QString);
	IWriter(const QString,const bool append);
	void setShort(const bool b=true);
	void setLong(const bool b=true);
	void setCdOnly(const bool b=true);
	
	virtual ~IWriter();
	
	void setFilename(const QString);
	QString getFilename() const;
	
	void deleteCurrentFile();
	void changeFile(const QString, const bool append=false);
	void openFile();
	void openFileAppend();
	void closeFile();
	void flush();
	
	virtual TextOStream* getStream();
	virtual void writeFooter(const QString str="")=0;
	virtual void write(CD* m,const bool onePerFile=false)=0;
    };
    
} //close namespace WriterSpace

#endif

