/* --------------------------------------------------------------------------
   
   Domo - Dirks (Oberon) Music Organizer (http://domo.sf.net)

   Copyright (C) 2001 Dirk Gorissen, All Rights Reserved
   
   This application is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation;
   
   This application is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.
   
   You should have received a copy of the GNU General Public
   License along with this application; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

----------------------------------------------------------------------------*/
#ifndef INC_METAINFO_H
#define INC_METAINFO_H

#ifndef INC_TRACK_H
#include "track.h"
#define INC_TRACK_H
#endif

using TrackSpace::Track;

class MetaInfo {
    private:
    static void getMp3Info(Track* t, const bool override);
    static void getOggInfo(Track* t, const bool override);
    static void getWmaInfo(Track* t, const bool override);
    static void getWavInfo(Track* t, const bool override);

    public:
    MetaInfo();
    ~MetaInfo();
    static void getMetaInfo(Track* trk, const bool override);
    static Track* getMetaInfo(const QString path, const bool override);
    static void writeMetaInfo(const Track* t);
    //given a file path and a music expression, this method creates a filename following the expression
    //and using data from the metatag
    static QString filenameFromTag(const QString filepath, const QString fnameExpression);
    static void writeTagsFromFilename(const QString filepath, const QString expression);
};

#endif
