/* --------------------------------------------------------------------------
   
   Domo - Dirks (Oberon) Music Organizer (http://domo.sf.net)

   Copyright (C) 2001 Dirk Gorissen, All Rights Reserved
   
   This application is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation;
   
   This application is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.
   
   You should have received a copy of the GNU General Public
   License along with this application; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

----------------------------------------------------------------------------*/
#ifndef INC_IOEXCEPTION_H
#include "ioexception.h"
#define INC_IOEXCEPTION_H
#endif

#ifndef INC_MOVIECD_H
#include "moviecd.h"
#define INC_MOVIECD_H
#endif

using MediaSpace::MovieCD;
using TrackSpace::Track;
using FileSpace::File;
//-----------------------------------------------------------------------------------------------------------
MovieCD::MovieCD() : CD() {
    fGenre = "";
}
//-----------------------------------------------------------------------------------------------------------
MovieCD::MovieCD(const QString s) : CD() {
    fTitle = s;
    fGenre = "";
}
//-----------------------------------------------------------------------------------------------------------
MovieCD::~MovieCD() {
}
//-----------------------------------------------------------------------------------------------------------
QString MovieCD::getGenre() const {
	return fGenre;
}
//-----------------------------------------------------------------------------------------------------------
void MovieCD::setGenre(const QString g){
	fGenre = g;
}
//-----------------------------------------------------------------------------------------------------------
void MovieCD::writeTxt(TextOStream* ostr) const {
    if ((ostr == 0)||(!ostr->isGood())) throw (new IoException("MovieCD::writeTxt","Pre: Ostream is 0 or not good"));
    
    CD::writeTxt(ostr);
    
    switch (ostr->getMode()) {
    case TextOStream::SHORT:
	break;
    case TextOStream::LONG:
	break;
    default:
	break;
    }
    writeTxtFileList(ostr);	
    
   if ((ostr == 0)||(!ostr->isGood())) throw (new IoException("MovieCD::writeTxt","Post: Ostream is 0 or not good"));
}
//-----------------------------------------------------------------------------------------------------------
void MovieCD::writeHtml(TextOStream* ostr) const{
    if ((ostr == 0)||(!ostr->isGood())) throw (new IoException("MovieCD::writeHtml","Pre: Ostream is 0 or not good"));
    
    CD::writeHtml(ostr);
    
    switch (ostr->getMode()) {
    case TextOStream::SHORT:
	break;
    case TextOStream::LONG:
    default:
	break;
    }
    writeHtmlFileList(ostr);	
    
    if ((ostr == 0)||(!ostr->isGood())) throw (new IoException("MovieCD::writeHtml","Post: Ostream is 0 or not good"));
}
//-----------------------------------------------------------------------------------------------------------
QString MovieCD::getTypeString() const {
    return  "MOVIE_CD";    
}
//-----------------------------------------------------------------------------------------------------------
