/* --------------------------------------------------------------------------
   
   Domo - Dirks (Oberon) Music Organizer (http://domo.sf.net)

   Copyright (C) 2001 Dirk Gorissen, All Rights Reserved
   
   This application is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation;
   
   This application is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.
   
   You should have received a copy of the GNU General Public
   License along with this application; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

----------------------------------------------------------------------------*/

#ifndef INC_MP3CD_H
#define INC_MP3CD_H


#ifndef INC_CD_H
#include "cd.h"
#define INC_CD_H
#endif

#ifndef INC_TRACK_H
#include "track.h"
#define INC_TRACK_H
#endif

#ifndef INC_FILE_H
#include "file.h"
#define INC_FILE_H
#endif

#ifndef INC_TEXTOSTREAM_H
#include "textostream.h"
#define INC_TEXTOSTREAM_H
#endif

using TrackSpace::Track;
using FileSpace::File;

namespace MediaSpace {

class Mp3CD: public CD {
      private:
              QString fGenre;

      public:
             Mp3CD();
             Mp3CD(const int);

             virtual ~Mp3CD();

             QString getGenre() const;
             void setGenre(const QString);
	
	void setTracklist(Track::Tracklist& tlist);
	virtual void writeTxt(TextOStream* ostream) const;
	virtual void writeHtml(TextOStream* ostream) const;
	virtual void writeM3u(TextOStream* ostream) const;
	virtual void writeB4s(TextOStream* ostream) const;
	virtual void writePls(TextOStream* ostream) const;
	virtual void writeCsv(TextOStream* ostream, const QStringList& fields) const;
		
	virtual QString getTypeString() const;
    };

} //Close namespace MediaSpace

#endif


