/* --------------------------------------------------------------------------
   
   Domo - Dirks (Oberon) Music Organizer (http://domo.sf.net)

   Copyright (C) 2001 Dirk Gorissen, All Rights Reserved
   
   This application is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation;
   
   This application is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.
   
   You should have received a copy of the GNU General Public
   License along with this application; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

----------------------------------------------------------------------------*/
#include "assert.h"
#include "qdatetime.h"

void MusicBrainzDialog::init() {
    yearField->setValue(QDate::currentDate().year());
    albumList->adjustColumn(0);
    albumList->adjustColumn(1);
    albumList->adjustColumn(2);
    albumList->adjustColumn(3);
}

void MusicBrainzDialog::addAlbum( const QString id, const QString title, const QString artist, const QString tracks )
{
    QListViewItem* item = new QListViewItem(albumList, artist, title, tracks, id);
    albumList->insertItem(item);
}

QString MusicBrainzDialog::getSelectedId()
{
    QListViewItem* item = albumList->selectedItem();
    if (item == 0) {
	return "";
    } else {
	return item->text(3);
    }
}

QString MusicBrainzDialog::getSelectedTracks()
{
    QListViewItem* item = albumList->selectedItem();
    if (item == 0) {
	return "";
    } else {
	return item->text(2);
    }
    
}

void MusicBrainzDialog::setGenreList(QStringList* slist) const{
    assert(slist != 0);
    genreField->insertStringList(*slist,1);
}

QString MusicBrainzDialog::getGenre() const {
    return genreField->currentText();
}

int MusicBrainzDialog::getYear() const{
    return yearField->value();
}
