/* --------------------------------------------------------------------------
   
   Domo - Dirks (Oberon) Music Organizer (http://domo.sf.net)

   Copyright (C) 2001 Dirk Gorissen, All Rights Reserved
   
   This application is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation;
   
   This application is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.
   
   You should have received a copy of the GNU General Public
   License along with this application; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

----------------------------------------------------------------------------*/

#ifndef INC_MUSICEXPRESSION_H
#define INC_MUSICEXPRESSION_H

#include "qmap.h"
#include "track.h"

using TrackSpace::Track;

class MusicExpression {
private:
public:
    MusicExpression();
    ~MusicExpression();
    
    static QString translateToRegex(const QString pat);
    static QString translateToRegex(const QString pat, QMap<QString, uint>& indexMap);
    static QString fitToPattern(const QString src, const QString pattern, const QString fitPattern);
    static Track* makeTrack(const QString pattern, const QString source);
    static bool matchesPattern(const QString pattern, const QString source);
    static QString makeFilename(const Track* t, const QString expression);
};

#endif
