/*-----------------------------------------------------------------------
QMBTagger - Qt Based MusicBrainz MP3/OGG Tagger
Copyright (C) 2003  Ewen Cheslack-Postava

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-----------------------------------------------------------------------*/

#ifndef _QMBFILE_H_
#define _QMBFILE_H_

#include <qstring.h>
#include <qmbtagger/qmbmetadata.h>
#include <musicbrainz/musicbrainz.h>
#include <musicbrainz/mb_c.h>

class QMBFile
{
public:
	QMBFile();
	virtual ~QMBFile() = 0;

	virtual int Extract(QString filename) = 0;
	int CreateID(trm_t &trm);
	int QueryServer(MusicBrainz* mb);
	virtual int Output(int resultChoice, QString format, QString newdir, bool crossfs) = 0;
	void CopySelectedMetadata(int resultChoice);
	void StripURL(QString &url);

	long bufferlen;
	char* buffer;
	int channels;
	long sampleRate;
	double songlength;
	char signature[17];
	char ascii_sig[37];
	QString fullfilename;
	QString serverurl;
	int serverport;

	//metadata
	QMBMetadata metadata;
	QMBMetadata* queryresults;
	int numresults;
};

#endif //define _QMBFILE_H_
