/* --------------------------------------------------------------------------
    Domo - Dirks (Oberon) Music Organizer (http://domo.sf.net)
   Copyright (C) 2001 Dirk Gorissen, All Rights Reserved
   
12/2003 adapted from:
   
QMBTagger - Qt Based MusicBrainz MP3/OGG Tagger
Copyright (C) 2003  Ewen Cheslack-Postava

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-----------------------------------------------------------------------*/

#ifndef _QMBFILEVIEW_H_
#define _QMBFILEVIEW_H_

#include <qlistview.h>
#include <qintdict.h>
#include <qstring.h>	
#include <qstringlist.h>
#include <qsettings.h>
#include "qmbfile.h"
#include "qmbsubmit.h"
#include <musicbrainz/musicbrainz.h>
#include <musicbrainz/mb_c.h>

class QMBFileView : public QListView
{
	Q_OBJECT
public:
	QMBFileView(QWidget* parent = 0, const char* name = 0, WFlags f = 0 );
	~QMBFileView();

	int NumSavedTRMs();
	bool Authenticate();
	void TransmitSettings(QSettings* newsettings);
	
	/*Added by Dirk Gorissen 12/2003 for domo (http://domo.sf.net) */
	bool getFirstSelected(QString& artist, QString& title, QString& album) const;
	/*Added by Dirk Gorissen 12/2003 for domo (http://domo.sf.net) */
	bool addSelectedFileForSubmission();
   public slots:
	void SetFilenames(const QStringList & filelist);
	void QueryServer();
	void OutputSelected();
	void setOptions(QString server, int port, QString proxy, int pport, QString filenameformat, QString outputdir, bool copycrossfs, QString user, QString pass);
	void SubmitTRMs();

signals:
	void ExtractedFileData(const QString&);
	void CreatedId(const QString&);
	void QueriedServer(const QString&);
	void AddedResultsToList(const int&);
	void AddedResultsToList();
	void OutputtedFile(const QString&);
	void FinishedQuerying(const QString&);
	void FinishedOutputting(const QString&);
	void SubmittedTRMs(const QString&);
	//dummy signals to pass on signal from QMBTagger (which gets it from QMBConfig)
	void SaveTRMs();
	void LoadTRMs();
private:
	QString format;
	QString newdir;
	bool crossfs;
	QIntDict<QMBFile> files;
	QIntDict<QListViewItem> listparents;
	QStringList filenames;
	MusicBrainz* mb;
	trm_t trm;
	QMBSubmit submit;
	bool authenticated;
	QString username, password;
};

#endif //define _QMBFILEVIEW_H_
