/*-----------------------------------------------------------------------
QMBTagger - Qt Based MusicBrainz MP3/OGG Tagger
Copyright (C) 2003  Ewen Cheslack-Postava

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-----------------------------------------------------------------------*/

#ifndef _QMBMAD_H_
#define _QMBMAD_H_

#include <mad.h>
#include <stdio.h>

class QMBmad {
private:

#if (MAD_VERSION_MAJOR>=1) || ((MAD_VERSION_MAJOR==0) && (((MAD_VERSION_MINOR==14) && (MAD_VERSION_PATCH>=2)) || (MAD_VERSION_MINOR>14)))
#define MadErrorString(x) mad_stream_errorstr(x)
#else
	static const char* MadErrorString (const struct mad_stream *Stream);
#endif

	static signed int scale(mad_fixed_t sample);
public:
	static int ReadMPEG(FILE* file, char* buffer, int bufferlen);

};

#endif //define _QMBMAD_H_
