/* --------------------------------------------------------------------------
   
   Domo - Dirks (Oberon) Music Organizer (http://domo.sf.net)

   Copyright (C) 2001 Dirk Gorissen, All Rights Reserved
   
   This application is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation;
   
   This application is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.
   
   You should have received a copy of the GNU General Public
   License along with this application; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

----------------------------------------------------------------------------*/

#ifndef INC_RCMAN_H
#define INC_RCMAN_H

#include <map>
#include "settings.h"
#include "readertxt.h" 
#include "qstringlist.h"

using std::map;
using ReaderSpace::ReaderTxt;

namespace ResourceSpace {
    
    class RcMan {
	private:
	QString fExtInfoFile;
	QString fGenreListFile;
	QString fArtistSafeListFile;
	QString fKeywordFile;
	QString fHyphenedArtistFile;
	map<QString,QString> fExtInfoList;
	QStringList fArtistSafeList;
	QStringList fGenreList;
	QStringList fKeywordList;
	QStringList fHyphenedArtistList;
	
	public:
	RcMan(const Settings* settings);
	~RcMan();
	
	void readExtensionInfo();
	
	void parseAll();
	
	QString resolveGenre(const uint i) const;
	void read(QStringList& slist,const QString s) const;
	
	bool isSafeArtist(const QString artist) const;	
	bool startsWithSafeArtist(const QString s1) const;
	bool isKeyword(const QString s) const;		  
	bool containsHyphenedArtist(const QString s) const;
	void addHyphenedArtist(const QString s);
	void flushHyphenedArtists() const;
	
	QString getExtDesc(const QString);
	QStringList* getGenreListRef();
	
    };
    
    
} //Close namespace ResourceSpace

#endif

