/* --------------------------------------------------------------------------
   
   Domo - Dirks (Oberon) Music Organizer (http://domo.sf.net)

   Copyright (C) 2001 Dirk Gorissen, All Rights Reserved
   
   This application is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation;
   
   This application is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.
   
   You should have received a copy of the GNU General Public
   License along with this application; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

----------------------------------------------------------------------------*/
#ifndef INC_IOEXCEPTION_H
#include "ioexception.h"
#define INC_IOEXCEPTION_H
#endif

#ifndef INC_READERTXT_H
#include "readertxt.h"
#define INC_READERTXT_H
#endif

#ifndef INC_STRINGMANIP_H
#include "stringmanip.h"
#define INC_STRINGMANIP_H
#endif

using std::cout;
using std::map;
using std::vector;
using ReaderSpace::IReader;
using ReaderSpace::ReaderTxt;
using TrackSpace::Track;

//-----------------------------------------------------------------------------------------------------------
ReaderTxt::ReaderTxt(const QString s) : IReader(s){
}
//-----------------------------------------------------------------------------------------------------------
ReaderTxt::~ReaderTxt(){
}
//-----------------------------------------------------------------------------------------------------------
void ReaderTxt::read(Track::Tracklist& tlist) {
  TextIStream* istream = getStream();
  
  if ((istream == 0) || (!istream->isGood())) throw (new IoException("ReaderTxt::read(Tracklist&)","Pre: Istream is 0 or not good"));
    QString tmp = "";
    int count = 0;
    
    while (istream->isGood()){
	tmp = "";
	istream->getLine(tmp);
	if (!tmp.isEmpty()) {
	    ++count;
	    Track* t = TrackSpace::makeTrack(tmp);
	    t->setTrackNo(count);
	    tlist.push_back(t);
	}
    }
    
   if ((istream == 0) || (!istream->isOpen())) throw (new IoException("ReaderTxt::read(Tracklist&)","Post: Istream is 0 or not open"));
}
//-----------------------------------------------------------------------------------------------------------
void ReaderTxt::read(QStringList& slist) {
   TextIStream* istream = getStream();
    if ((istream == 0) || (!istream->isGood())) throw (new IoException("ReaderTxt::read(QStringList&)","Pre: Istream is 0 or not good"));
    
    QString tmp = "";
    while (istream->isGood()){
	tmp = "";
	istream->getLine(tmp);
	//cout<<"read: "<< tmp << "\n";
	if (!tmp.isEmpty()) {
	    slist.push_back(tmp);
	}
    }
    
    if ((istream == 0) || (!istream->isOpen())) throw (new IoException("ReaderTxt::read(QStringList&)","Post: Istream is 0 or not open"));
}
//-----------------------------------------------------------------------------------------------------------
void ReaderTxt::readColumns(map<QString,QString>& map, const char sep) {
   TextIStream* istream = getStream();
   if ((istream == 0) || (!istream->isGood())) throw (new IoException("ReaderTxt::read(map<string,string>)","Pre: Istream is 0 or not good"));
    QString desc = "";
    QString line = "";
   	
    while (istream->isGood()){
	istream->getLine(line);
	splitOnFirstSep(line,sep,desc);
	map[line] = trim(desc);
	
	DomoGlobals::logger->debug("ReaderTxt::read(map<QString,QString>)","Added pair: "  + line + " / " + desc);
    }
   if ((istream == 0) || (!istream->isOpen())) throw (new IoException("ReaderTxt::read(map<string,string>)",
								  "Post: Istream is 0 or not open"));
}
//-----------------------------------------------------------------------------------------------------------

