/* --------------------------------------------------------------------------
   
   Domo - Dirks (Oberon) Music Organizer (http://domo.sf.net)

   Copyright (C) 2001 Dirk Gorissen, All Rights Reserved
   
   This application is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation;
   
   This application is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.
   
   You should have received a copy of the GNU General Public
   License along with this application; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

----------------------------------------------------------------------------*/

#ifndef INC_TRACK_H
#include "track.h"
#define INC_TRACK_H
#endif

#include "assert.h"

void SkipTrack::setTrack(const TrackSpace::Track* t) {
    assert(t!=0);
    QString tmp = "";
    QString na = "<font color=\"blue\">N/A</font>";
    
    trackName->setText("<font color=\"blue\">" + QString(t->getName()) + "</font>");
    
    if (t->getSize() != 0) {
	size->setText("<font color=\"blue\">" + tmp.setNum( t->getSize()/1000 ) + "</font>");
    } else {
	size->setText(na);
    }
    
    if (t->getLength() != 0) {
	length->setText("<font color=\"blue\">" + tmp.setNum(t->getLength()) + "</font>");
    } else {
	length->setText(na);    
    }
    
    if (t->getBitrate() != 0) {
	bitrate->setText("<font color=\"blue\">" + tmp.setNum(t->getBitrate()) + "</font>");
    } else {
    	bitrate->setText(na);
    }
    
}


void SkipTrack::skipAndDelete()
{
    done(1);
}


void SkipTrack::skip()
{
    done(2);
}


void SkipTrack::dontSkip()
{
    done(3);
}
