/* --------------------------------------------------------------------------
   
   Domo - Dirks (Oberon) Music Organizer (http://domo.sf.net)

   Copyright (C) 2001 Dirk Gorissen, All Rights Reserved
   
   This application is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation;
   
   This application is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.
   
   You should have received a copy of the GNU General Public
   License along with this application; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

----------------------------------------------------------------------------*/

#ifndef INC_DBASE_H
#include "dbase.h"
#define INC_DBASE_H
#endif

bool StatsDialog::getStats(DbaseSpace::Dbase* fDB) {
 assert(fDB != 0);
 QString tmp = "";
 collectionCount->setText(tmp.setNum(fDB->queryNum("SELECT COUNT(*) FROM Collection;")));
 totalTrackCount->setText(tmp.setNum(fDB->queryNum("SELECT COUNT(*) FROM Track;")));
 fileCount->setText(tmp.setNum(fDB->queryNum("SELECT COUNT(*) FROM File;")));
 cdCount->setText(tmp.setNum(fDB->queryNum("SELECT COUNT(*) FROM CD;")));
 totalLength->setText(tmp.setNum((fDB->queryNum("SELECT SUM(length) FROM Track;"))/3600));
 dupTrackCount->setText(tmp.setNum(fDB->getResultSetSize("SELECT name FROM Track GROUP BY name HAVING (count(*) > 1);")));
 artistCount->setText(tmp.setNum(fDB->getResultSetSize("SELECT COUNT(*) FROM Track GROUP BY artist;")));
 
 albumCount->setText(tmp.setNum(fDB->queryNum("SELECT COUNT(*) FROM Album;")));
 mp3cdCount->setText(tmp.setNum(fDB->queryNum("SELECT COUNT(*) FROM Mp3CD;")));
 moviecdCount->setText(tmp.setNum(fDB->queryNum("SELECT COUNT(*) FROM MovieCD;")));
 audiocdCount->setText(tmp.setNum(fDB->queryNum("SELECT COUNT(*) FROM AudioCD;")));
 datacdCount->setText(tmp.setNum(fDB->queryNum("SELECT COUNT(*) FROM DataCD;")));
 
 avgMp3->setText(tmp.setNum(fDB->queryNum("SELECT AVG(trackcount) FROM Mp3CD;")));
 avgAudio->setText(tmp.setNum(fDB->queryNum("SELECT AVG(trackcount) FROM AudioCD;")));
 avgMovie->setText(tmp.setNum(fDB->queryNum("SELECT AVG(filecount) FROM MovieCD;")));
 avgData->setText(tmp.setNum(fDB->queryNum("SELECT AVG(filecount) FROM DataCD;")));
 
 QSqlQuery q; 
 fDB->query("SELECT genre, COUNT(*) as cnt from Track GROUP BY (genre) ORDER BY cnt DESC limit 10;",q);
 
 QString genre = "";
 QString cnt = "";
 int r = 0;
 if ( q.isActive() ) {
  while (q.next()) {
   genre  = q.value(0).toString();
   cnt  = q.value(1).toString();
   if(genre.isEmpty()) genre = "<no genre set>";
   genreTop10->setText(r,0,genre);
   genreTop10->setText(r,1,cnt);
   ++r;
  }
 } else {
  return false;
 }
 
 fDB->query("SELECT artist,COUNT(*) as cnt from Track GROUP BY (artist) ORDER BY cnt DESC limit 10;",q);
 
 r = 0;
 QString artist = "";
 cnt = "";
 if  ( q.isActive() ) {
  while (q.next()) {
   artist= q.value(0).toString();
   cnt  = q.value(1).toString();
   artistTop10->setText(r,0,artist);
   artistTop10->setText(r,1,cnt);
   ++r;
  }
 } else {
  return false;
 }
 
 fDB->query("SELECT artist,AVG(score) as avg from Track GROUP BY (artist) ORDER BY avg DESC limit 10;",q);
 
 r = 0;
 artist = "";
 cnt = "";
 if  ( q.isActive() ) {
                moodPopularity->setNumRows(q.size());
  while (q.next()) {
   artist= q.value(0).toString();
   cnt  = q.value(1).toString();
   bestScoringArtists->setText(r,0,artist);
   bestScoringArtists->setText(r,1,cnt);
   ++r;
  }
 } else {
  return false;
 }
 
 fDB->query("SELECT mood,COUNT(*) as cnt from Track GROUP BY (mood) ORDER BY cnt DESC;",q);
               
 r = 0;
 QString mood = "";
 cnt = "";
 if  ( q.isActive() ) {
  while (q.next()) {
   mood= q.value(0).toString();
   cnt  = q.value(1).toString();
   if(mood.isEmpty()) mood = "<no mood set>";
   moodPopularity->setText(r,0,mood);
   moodPopularity->setText(r,1,cnt);
   ++r;
  }
 } else {
  return false;
 } 
                
                artistTop10->adjustColumn(0);
 artistTop10->adjustColumn(1);
 genreTop10->adjustColumn(0);
 genreTop10->adjustColumn(1);
 bestScoringArtists->adjustColumn(0);
 bestScoringArtists->adjustColumn(1);
                moodPopularity->adjustColumn(0);
 moodPopularity->adjustColumn(1);
 
 int mp3Count = fDB->queryNum("SELECT COUNT(id) FROM Track WHERE name LIKE '%.mp3';");
 int oggCount = fDB->queryNum("SELECT COUNT(id) FROM Track WHERE name LIKE '%.ogg';");
 int wmaCount = fDB->queryNum("SELECT COUNT(id) FROM Track WHERE name LIKE '%.wma';");
 int cdaCount = 0; //fDB->queryNum("SELECT COUNT(id) FROM Track WHERE cdno IN (SELECT id FROM AudioCD);");
 int otherCount = fDB->queryNum("SELECT count(id) FROM Track WHERE name not like '%.___';");
 
 fileTypes->setText(0,0,tmp.setNum(mp3Count));
 fileTypes->setText(1,0,tmp.setNum(oggCount));
 fileTypes->setText(2,0,tmp.setNum(wmaCount));
 fileTypes->setText(3,0,"N/A");
 fileTypes->setText(4,0,tmp.setNum(otherCount));
 ++cdaCount;
 return true;
}
