/* --------------------------------------------------------------------------
   
   Domo - Dirks (Oberon) Music Organizer (http://domo.sf.net)

   Copyright (C) 2001 Dirk Gorissen, All Rights Reserved
   
   This application is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation;
   
   This application is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.
   
   You should have received a copy of the GNU General Public
   License along with this application; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

----------------------------------------------------------------------------*/

#ifndef INC_TEXTISTREAM_H
#define INC_TEXTISTREAM_H

#include "qtextstream.h"
#include "qstring.h"

namespace ReaderSpace {
	class TextIStream : public QTextStream {
	public:
		TextIStream(const QString filename);
		virtual ~TextIStream();
		
		bool isOpen() const;
		bool isGood() const;
		bool atEnd() const;
		
		bool isComment(const QString s);
		void getLine(QString& s, const bool ignoreComments = true, const bool ignoreEmptyLines=true);
		//void get(char& ch);
		int line();
	private:
		QString fName;
		int fLine;
	};
}
#endif
