/* --------------------------------------------------------------------------
   
   Domo - Dirks (Oberon) Music Organizer (http://domo.sf.net)

   Copyright (C) 2001 Dirk Gorissen, All Rights Reserved
   
   This application is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation;
   
   This application is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.
   
   You should have received a copy of the GNU General Public
   License along with this application; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

----------------------------------------------------------------------------*/

#ifndef INC_TEXTOSTREAM_H
#define INC_TEXTOSTREAM_H

#include "qtextstream.h"

namespace WriterSpace {
	class TextOStream : public QTextStream {
	public:
		//TODO: use inheritance instead of enum
		enum Mode {SHORT,LONG};
		
		TextOStream(const QString filename, int mode=IO_WriteOnly);
		virtual ~TextOStream();
		
		void setMode(const Mode m);
		bool isShort() const;
		bool isLong() const;
		bool isCdOnly() const;
		void setCdOnly(const bool b);
		Mode getMode() const;
		
		bool isOpen() const;
		bool isGood() const;
		bool atEnd() const;
		void flush();
		void close();
		
	private:
		Mode fMode;
		QString fName;
		bool fCdOnly;
	};
}
#endif
