/* --------------------------------------------------------------------------
   
   Domo - Dirks (Oberon) Music Organizer (http://domo.sf.net)

   Copyright (C) 2001 Dirk Gorissen, All Rights Reserved
   
   This application is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation;
   
   This application is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.
   
   You should have received a copy of the GNU General Public
   License along with this application; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

----------------------------------------------------------------------------*/
#ifndef INC_IOEXCEPTION_H
#include "ioexception.h"
#define INC_IOEXCEPTION_H
#endif

#ifndef INC_WRITERPLS_H
#include "writerpls.h"
#define INC_WRITERPLS_H
#endif

using WriterSpace::IWriter;
using FileSpace::File;
using WriterSpace::WriterPls;

//-----------------------------------------------------------------------------------------------------------
WriterPls::WriterPls(const QString s) : IWriter(s){
    fCounter = 0;
}
//-----------------------------------------------------------------------------------------------------------
WriterPls::~WriterPls(){
}
//-----------------------------------------------------------------------------------------------------------
void WriterPls::writeHeader(const QString s) {
    TextOStream* ostream = getStream();
    if ((ostream == 0) || (!ostream->isGood())) throw (new IoException("WriterPls::writeHeader","Pre: Ostream is 0 or not good"));

    *ostream << "[playlist]\n";
    
    if (s.isEmpty()) {
	*ostream << "PlaylistName=Playlist 001\n";
    } else {
	*ostream << "PlaylistName=" + s + "\n";
    }
    
    if ((ostream == 0) || (!ostream->isGood())) throw (new IoException("WriterPls::writeHeader","Post: Ostream is 0 or not good"));
}
//-----------------------------------------------------------------------------------------------------------
void WriterPls::writeFooter(const QString str) {
   TextOStream* ostream = getStream();

    if ((ostream == 0) || (!ostream->isGood())) throw (new IoException("WriterPls::writeFooter","Pre: Ostream is 0 or not good"));
    
    *ostream << "NumberOfEntries=" << fCounter << "\n";
    *ostream << "Version=2\n";
    fCounter = 0;
    if ((ostream == 0) || (!ostream->isGood())) throw (new IoException("WriterPls::writeFooter","Post: Ostream is 0 or not good"));
}
//-----------------------------------------------------------------------------------------------------------
void WriterPls::write(CD* m,const bool onePerFile){
  TextOStream* ostream = getStream();
    
    if (m == 0) throw (new IoException("WriterPls::write(CD*,bool)","Pre: CD is 0"));
    if ((ostream == 0) || (!ostream->isGood())) throw (new IoException("WriterPls::write(CD*,bool)","Pre: Ostream is 0 or not good"));
    
    if (onePerFile) {
	writeHeader();
    }
    
    m->writePls(ostream);
    fCounter += m->getFileCount();
    
    if (onePerFile) {
	writeFooter();
    }
    
    if ((ostream == 0) || (!ostream->isGood())) throw (new IoException("WriterPls::write(CD*,bool)","Post: Ostream is 0 or not good"));
}
//-----------------------------------------------------------------------------------------------------------







